# IMCUnknown Struct Reference
[COM Interfaces]

Inheritance diagram for IMCUnknown:

List of all members.

## Public Member Functions
virtual MCErr MCCOMAPI | QueryInterface (const MCIID &riid, void **ppvObj)=0
virtual uint32 MCCOMAPI | AddRef ()=0
virtual uint32 MCCOMAPI | Release ()=0

## Detailed Description

Defines the basic methods that every COM object must implement. Every COM object derives from it.

## Member Function Documentation

virtual uint32 MCCOMAPI IMCUnknown::AddRef | ( |  | ) | `[pure virtual]`

Increments the reference count of the object

Implemented in TCountedTimeBased, TBasicConstraint, TBasicNewConstraint, TBasicTweener, TBasicMenuCallBack, TBasicSceneCommand, TBasicAnimationMethod, TBasic3DEditorHostPanePart, TBasicPreviewPart, TBasicPreviewThread, TBasic3DExportFilter, TBasic3DImportFilter, TBasicAttributesSetControler, TBasicCamera, TBasicLight, TBasicGel, TBasicClip, TBasicDataComponent, TBasicDistantLight, TBasicAmbient, TBasicAtmosphere, TBasicBackdrop, TBasicBackground, TBasicFinalRenderer, TBasicGenericData, TBasicModifier, TBasicModule, TBasicPostRenderer, TBasicPrimitive, TBasicPropertiesClient, TBasicRendererBox, TBasicRenderFeature, TBasicShadowFeature, TBasicReflectionFeature, TBasicRefractionFeature, TBasicRigidBodySolver, TBasicShader, TBasicTerrainFilter, TBasicVolumetricCloudsShape, TBasicVolumetricEffect, TCountedRenderable, TCountedRenderingCallbacks, TImportFileData, TBasicObjectFactory, TBasicUnknown, TBasicDataExchanger, TBasicRegisterer, TBasicColorPicker, TBasicColorSet, TBasicPart, TBasicListPart, TBasicAction, TBasicMouseAction, TBasicDropArea, TBasicDropCandidate, TBasicMovie, TBasicParamType, TBasicPrefsComponent, TBasicRemoteInstructions, TBasicSmpThread, TBasicThread, TSimpleHierarchyItem< T >, TMCCountedObject, TMCSMPCountedObject, and TMCSocket.

virtual MCErr MCCOMAPI IMCUnknown::QueryInterface | ( | const MCIID & | riid,
|  | void ** | ppvObj |
| ) |  |  | `[pure virtual]`

Check if the object supports a given interface and returns a pointer to that interface if it does. Note that QueryInterface will increment the reference count of the object by one if the interface is found.

Parameters:

  | riid | GUID of the interface
  | ppvObj | A pointer to the pointer being returned.

Implemented in TTimeBased, TCountedTimeBased, TBasicConstraint, TBasicNewConstraint, TBasicTweener, TBasicMenuCallBack, TBasicSceneCommand, TBasicAnimationMethod, TBasic3DEditorHostPanePart, TBasicPreviewPart, TBasicPreviewThread, TBasic3DExportFilter, TBasic3DImportFilter, TBasicAttributesSetControler, TBasicCamera, TBasicLight, TBasicGel, TBasicClip, TBasicDataComponent, TBasicDistantLight, TBasicAmbient, TBasicAtmosphere, TBasicBackdrop, TBasicBackground, TBasicFinalRenderer, TBasicGenericData, TBasicModifier, TBasicModule, TBasicPostRenderer, TBasicPrimitive, TBasicPropertiesClient, TBasicRendererBox, TBasicRenderFeature, TBasicShadowFeature, TBasicReflectionFeature, TBasicRefractionFeature, TBasicRigidBodySolver, TBasicShader, TBasicTerrainFilter, TBasicVolumetricCloudsShape, TBasicVolumetricEffect, TBasicWireframe, TBasicWireframeSet, TCountedRenderable, TCountedRenderingCallbacks, TImportFileData, TBasicObjectFactory, TBasicUnknown, TBasicDataExchanger, TBasicRegisterer, TBasicColorPicker, TBasicColorSet, TBasicPart, TBasicListPart, TBasicAction, TBasicMouseAction, TBasicDropArea, TBasicDropCandidate, TBasicMovie, TBasicParamType, TBasicPrefsComponent, TBasicRemoteInstructions, TBasicSmpThread, TBasicThread, TSimpleHierarchyItem< T >, TMCCountedObject, TMCSMPCountedObject, and TMCSocket.

virtual uint32 MCCOMAPI IMCUnknown::Release | ( |  | ) | `[pure virtual]`

Decrements the reference count of the object. If the reference count reaches zero, the object is destroyed.

Implemented in TCountedTimeBased, TBasicMenuCallBack, TBasicPreviewThread, TBasicModule, TBasicPropertiesClient, TCountedRenderable, TCountedRenderingCallbacks, TImportFileData, TBasicMouseAction, TBasicParamType, TBasicRemoteInstructions, TBasicSmpThread, TBasicThread, TSimpleHierarchyItem< T >, TMCCountedObject, TMCSMPCountedObject, and TMCSocket.

The documentation for this struct was generated from the following file:

- MCCompObj.h